/***
*disked.h - definitions/declarations for DISKED DISK EDitor
*
*   Copyright (c) 1992-1994, Gregg Jennings.  All wrongs reserved.
*
*Purpose:
*   This file defines the values and macros for general purposes
*   as well as all DISKED function prototypes.
*   [ANSI/System V]
*
*******************************************************************************/

#ifndef GENERAL_H
#include "general.h"
#endif

extern const char *Title;
extern const char *Copyr;
extern const char *Namep;
extern const char *Version;
extern const char *Revision;
extern const char *Sn;

#define LOGICAL  1
#define PHYSICAL 0
#define DISP    TRUE
#define NODISP  FALSE
#define PAUSE   TRUE
#define NOPAUSE FALSE
#define XLATE   TRUE
#define NOXLATE FALSE
#define TWIDTH  80
#define TLENGTH 24
#define MAXSTR  63
#define SEARCH  63
#define MAX_DRIVE 26
#define FILE_LEN 13


#define cconin()   bdos(0x0c,0,7)      /* wait w/clear !echo !^C check */
/*#define cconin()   getch()             /* if bdos() not available */

struct Keys {                 /* "keywords" */
    unsigned int key;
    int opt;                  /* option value (boolean) */
    char *s;                  /* keyword */
};

struct Msg {                  /* generic number input messages */
    char *msg;                /* prompt */
    int len;                  /* length of input (e.g. 3 = 999 max) */
};

extern struct Keys kw[];
extern unsigned char *save_sec;        /* duplicate of sector buffer */

/* Defines to make it easy to use */

#define Radix   kw[15].opt
#define Translate kw[14].opt
#define Logical kw[13].opt
#define Partial kw[12].opt
#define Ascii   kw[11].opt
#define Debug   kw[10].opt
#define Files   kw[9].opt
#define Convert kw[8].opt
#define Strip   kw[7].opt
#define Write   kw[6].opt
#define Verify  kw[5].opt
#define Mask    kw[4].opt
#define Home    kw[3].opt
#define Get     kw[2].opt
#define Display kw[1].opt

#define exist(f)  (access(f,00)==0)

/* in disklib.obj */

extern void ext_commands(void);
extern void commands(void);
extern void command_line(void);
extern void signon_msg(void);
extern void dkey(struct Keys *str);
extern void ckey(char *s,struct Keys *str);
extern void psw(char c, struct Keys *str);
extern void header(void);
extern void dumpsector(void);
extern int get(struct Msg *str,int *one, int *two);
extern int getl(struct Msg *str,long *one, int *two);
extern int set(struct Msg *str,int *one,int *two,int *three);
extern int view(unsigned char *buffer,unsigned int bfptr,unsigned int bufend,int pause,int base);
extern int find(int val, int get,int kase);
extern void range(int val);
extern void dparams(char *drivedir);
extern void dumpboot(unsigned char *);
extern void help(void);

/* fileio */

extern int putfile(char *filename, int xlate, int mode, int m, int s, int c);
extern int getfile(char *file,int xlate, int m, int s, int c);
extern int append(int s,int m,int c,unsigned char *buffer,unsigned int nbytes);
extern int putsectors(char *, long, int);

/* function prototype in DISKED.C */

int _cdecl main(int argc,char **argv);

/* function prototypes are in setup.obj */

extern int setup(char **argv, int drives[], unsigned int *dsk);
extern void logerror(int i);
extern unsigned int numarg(char *arg, int radix);
extern int keyarg(char *arg,int key);
extern unsigned long longarg(char *arg, int radix);
extern int boolarg(char *arg);
extern void init(char *filename);
extern void viewfile(char *filename);
extern void status(int msg_index, char *s);
extern int prompt(int n, int base);
extern void saveinit(char *filename);
extern int getinit(char *filename);
extern int newdisk(int tempd);
extern void quit(int);
extern int do_files(void);

extern void debug(void);
extern void heapdump(int);
