/***
*error.h - definitions/declarations for errno/perror() like error handling
*
*Copyright (c) 1991-1994, Gregg Jennings.  All wrongs reserved.
*   P O Box 200, Falmouth, MA 02541-0200
*
*Purpose:
*   MS(tm)-DOS Disk EDitor.
*
*Notice:
*   This progam may be freely used and distributed.  Any distrubution
*   with modifications must retain the above copyright statement and
*   modifications noted.
*   No pulp-publication, in whole or in part, permitted without
*   permission (magazines or books).
*******************************************************************************/

extern void printerror(int ext);

/* errno-like error information */

struct error_t {
   const char *mod;                 /* module name */
   const char *func;                /* function name */
   const char *msg;                 /* error message */
   const char *arg;                 /* error argument */
   int  num;                        /* error number */
};

extern struct error_t error;
extern const char *err_msg[];       /* can change pointer but not object */

/* global (or shared) error conditions */

enum ERROR_MSG {
   REQ_DOS_3,                       /* files.c */
   NO_MEM,
   FAT_PHASE,
   INV_CLUS,
   INV_ST_CLUS,
   NUM_FILES,
   ALLOC_ZERO,                      /* alloc.c */
   FREE_NULL,
   HEAP_ERROR,
};
