/***
*files.h - definitions/declarations for keyboard input.
*
*Copyright (c) 1991-1994, Gregg Jennings.  All wrongs reserved.
*   P O Box 200, Falmouth, MA 02541-0200
*
*Purpose:
*   Define BIOS key scan codes
*   [ANSI]
*
*******************************************************************************/

/* KEY DEFINITIONS */

#define ALT_MSK     8
#define CTRL_MSK    4
#define SHFT_MSK    3

/* Actual Keybaord Scan Codes */

#define RETURN 0x1C0D
#define BACKSP 0x0E08
#define TAB    0x0F09
#define SHTAB  0x0F00
#define ESCAPE 0x011B

#define F1     0x3B00
#define F2     0x3C00
#define F3     0x3D00
#define F4     0x3E00
#define F5     0x3F00
#define F6     0x4000
#define F7     0x4100
#define F8     0x4200
#define F9     0x4300
#define F0     0x4400

#define SHFTF1 0x5400
#define SHFTF2 0x5500
#define SHFTF3 0x5600
#define SHFTF4 0x5700
#define SHFTF5 0x5800
#define SHFTF6 0x5900
#define SHFTF7 0x5A00
#define SHFTF8 0x5B00
#define SHFTF9 0x5C00
#define SHFTF0 0x5D00

#define CTRLF1 0x5E00
#define CTRLF2 0x5F00
#define CTRLF3 0x6000
#define CTRLF4 0x6100
#define CTRLF5 0x6200
#define CTRLF6 0x6300
#define CTRLF7 0x6400
#define CTRLF8 0x6500
#define CTRLF9 0x6600
#define CTRLF0 0x6700

#define ALTF1  0x6800
#define ALTF2  0x6900
#define ALTF3  0x6A00
#define ALTF4  0x6B00
#define ALTF5  0x6C00
#define ALTF6  0x6D00
#define ALTF7  0x6E00
#define ALTF8  0x6F00
#define ALTF9  0x7000
#define ALTF0  0x7100

#define ALTA   0x1E00
#define ALTB   0x3000
#define ALTC   0x2E00
#define ALTD   0x2000
#define ALTE   0x1200
#define ALTF   0x2100
#define ALTG   0x2200
#define ALTH   0x2300
#define ALTI   0x1700
#define ALTJ   0x2400
#define ALTK   0x2500
#define ALTL   0x2600
#define ALTM   0x3200
#define ALTN   0x3100
#define ALTO   0x1800
#define ALTP   0x1900
#define ALTQ   0x1000
#define ALTR   0x1300
#define ALTS   0x1F00
#define ALTT   0x1400
#define ALTU   0x1600
#define ALTV   0x2F00
#define ALTW   0x1100
#define ALTX   0x2D00
#define ALTY   0x1500
#define ALTZ   0x2C00

#define UP     0x4800
#define DOWN   0x5000
#define RIGHT  0x4D00
#define LEFT   0x4B00
#define HOME   0x4700
#define END    0x4F00
#define PGUP   0x4900
#define PGDN   0x5100
#define INS    0x5200
#define DEL    0x5300

#define SUP    0x4838
#define SDOWN  0x5032
#define SRIGHT 0x4D36
#define SLEFT  0x4B34
#define SHOME  0x4737
#define SEND   0x4F31
#define SPGUP  0x4939
#define SPGDN  0x5133
#define SINS   0x5230
#define SDEL   0x532E

#define CRIGHT 0x7400
#define CLEFT  0x7300
#define CHOME  0x7700
#define CEND   0x7500
#define CPGUP  0x8400
#define CPGDN  0x7600
#define CDEL   0x5300

/* Character Definitions */

#define CTRLA  0x0001
#define CTRLB  0x0002
#define CTRLC  0x0003
#define CTRLD  0x0004
#define CTRLE  0x0005
#define CTRLF  0x0006
#define CTRLG  0x0007
#define CTRLH  0x0008
#define CTRLI  0x0009
#define CTRLJ  0x000A
#define CTRLK  0x000B
#define CTRLL  0x000C
#define CTRLM  0x000D
#define CTRLN  0x000E
#define CTRLO  0x000F
#define CTRLP  0x0010
#define CTRLQ  0x0011
#define CTRLR  0x0012
#define CTRLS  0x0013
#define CTRLT  0x0014
#define CTRLU  0x0015
#define CTRLV  0x0016
#define CTRLW  0x0017
#define CTRLX  0x0018
#define CTRLY  0x0019
#define CTRLZ  0x001A
